utils = require '../lib/utils.js'
tumbler = require 'tumbler'

ARGUMENTS = [
    [ ["-t", "--target"], "target", true, "Target to build" ]
]

ARGUMENTS_PARSER = new utils.ArgumentParser
    args: ARGUMENTS
    configFile: ".tumbler"

help = ->
    ARGUMENTS_PARSER.help()

buildTarget = (builder, target)->
    success = -> console.log "success"
    failure = -> console.log "failure"
    builder.build target,success,failure

main = (argv)->    
    try
        config = ARGUMENTS_PARSER.parse argv
        builder = tumbler.makeBuilder config
        ARGUMENTS_PARSER.print config
        buildTarget builder, config.target
    catch e
        console.log e
        console.log e.stack
        help()

exports.main = main
exports.help = help
exports.DESCRIPTION = """
Build target.
"""

if require.main == module
    main process.argv[2..]
